 #include <MJDtime.h>
 #include <time.h>
 #include <stdio.h>
 #include <stdlib.h>
	/* Test program to run MJDtime */


int main()
{
	char buf[360];
	char copy[360];
	int y = 504;
	int m = 1;
	int d = 1;
	int hour = 0;
	int min =0;
	double sec = 0.0;
	const char *ISOstring;
	double epoch;
	int doy, doy2;
	double zeroTest;
	
	MJDtime MJD1;
	MJDtime MJD2;
	
	printf("Start date/time components: %d-%d-%d %d:%d:%13.11g\n", y, m, d, hour, min, sec);
	
	setFromUT(y, m, d, hour, min, sec, &MJD2);
	
	printf("MJD = %d, seconds = %17.15g\n", MJD2.base_day, MJD2.time_sec);
	printf( " MJD = %18.10f \n", getMJD(&MJD2));
	printf( " JD = %18.10f \n\n", getJD(&MJD2));
	
	doy = breakDownMJD(&y, &m,&d,&hour,&min,&sec, &MJD2);
	printf("date/time components: %d-%d-%d %d:%d:%13.11g\n\n", y, m, d, hour, min, sec );
	
	ISOstring = getISOString(&MJD2, 0);
	printf("ISO string = '%s'\n\n" , ISOstring);

	strfMJD(&(buf[0]), 360, "%Y-%m-%d %H:%M:%S%.",  &MJD2);
	printf("strfMJD:ISO equiv:   '%s'\n", buf);
	strfMJD(&(buf[0]), 360, "%Y-%m-%dT%H:%M:%S%4Z",  &MJD2);
	printf("strfMJD:ISO equiv:  '%s'\n", buf);
	
	printf("doy is  %ld\n", doy);
	setFromDOY(y, doy, hour, min, sec, &MJD1);
	
	zeroTest = getDiffSecs(&MJD1, &MJD2);
	printf("difference MJD (month/day) - MJD(doy) '%g'\n\n" , zeroTest);

	hour += 24;
	d -= 1;
	setFromUT(y, m, d, hour, min, sec, &MJD2);
	zeroTest = getDiffDays(&MJD1, &MJD2);
	printf("difference MJD (d-1, h+24) - MJD(d, h) '%g'\n\n" , zeroTest);
	
	epoch = getCDFepoch(&MJD2);
	printf("CDF epoch sec %18.3f\n", epoch);
	setFromCDFepoch(epoch, &MJD2);
	printf("from CDF ISO string (CDF epoch is accurate to msec only) = '%s'\n" , getISOString(&MJD2, 1));
    
	printf("Day of week is/was %s\n\n", getDayOfWeek(&MJD2));
	
	ISOstring = getISOString(&MJD1,0);
	printf("ISO string = '%s'\n\n" , ISOstring);
	setFromISOstring(ISOstring, &MJD1);
	printf("for %s, MJD = %d, seconds = %17.11g\n", ISOstring, MJD1.base_day, MJD1.time_sec);
	ISOstring = getISOString(&MJD1,1);
	printf("ISO string = '%s'\n\n" , ISOstring);
	setFromISOstring(ISOstring, &MJD1);
	printf("for %s, MJD = %d, seconds = %17.11g\n\n", ISOstring, MJD1.base_day, MJD1.time_sec);

/* try julian/gregorian changeover */
	y = 1752;
	m = 10;
	d = 4;
	hour = 0;

	setGregorianStartMJD(0);
	
	setFromUT(y, m, d, hour, min, sec, &MJD1);
	strcpy(&(copy[0]), getISOString(&MJD1,0)); /* copy because getISOString() returns a pointer to a static string */
	printf("Julianian = '%s'\n" , &(copy[0]));
	setGregorianStartMJD(-200840);
	printf("%s Julian = '%s' Gregorian, (give us back our 11 days)\n" , &(copy[0]), getISOString(&MJD1,1));
	setFromUT(y, m, d, hour, min, sec, &MJD2);

	/* test diff */
	printf("diff in days between %s J and %s G is %f\n", &(copy[0]), getISOString(&MJD2,1), getDiffDays(&MJD1, &MJD2));
	printf("diff in seconds between %s J and %s G is %f\n", &(copy[0]), getISOString(&MJD2,1), getDiffSecs(&MJD1, &MJD2));
	
/* Compare formatting from strftime() */
	setGregorianStartMJD(-100840);

	size_t used = strfMJD(&(buf[0]), 360, "   strfMJD():\n   --------\n '%+' \n %c\n %D %F \n %j \n %r \n %s \n %v\n\n",  &MJD2);

	/* seconds since 01 Jan 1970 Gregorian for strftime use */				
	time_t localt = MJD2.time_sec + (MJD2.base_day - 40587) * 86400;
	struct tm *ptm;
	ptm = gmtime(&localt);
	strftime(&(buf[0]), 360, "  strftime(): (invalid before 1970)\n   ------\n '%+' \n %c\n %D %F \n %j \n %r \n %s \n %v", ptm);
	printf("%s\n" , buf);
	int y1, y2;
/*	for(y = -1000; y<=2000; y++)
	{
		y1=y;
		y2 = y;
		m=1;
		d=1;
		setFromUT(y1, m, d, hour, min, sec, &MJD1);
		doy = breakDownMJD(&y1, &m,&d,&hour,&min,&sec, &MJD1);
		
		m=12;
		d=31;
		setFromUT(y2, m, d, hour, min, sec, &MJD2);
		doy2 = breakDownMJD(&y2, &m,&d,&hour,&min,&sec, &MJD2);
		printf("y=%d d=%d & y=%d d=%d\n", y, doy, y2, doy2);
	}
*/	
	setFromMJD(-100841, &MJD1);
	strfMJD(&(buf[0]), 360, "%a %Y-%m-%d %H:%M:%S%.",  &MJD1);
	printf(	"%s\n" , buf);

	setFromMJD(-100840, &MJD1);
	strfMJD(&(buf[0]), 360, "%a %Y-%m-%d %H:%M:%S%.",  &MJD1);
	printf(	"%s\n" , buf);

	setFromMJD(51910, &MJD1);
	MJD1.time_sec = 3600.;
	printf("mjd %d %f\n", MJD1.base_day, MJD1.time_sec);
	breakDownMJD(&y, &m, &d, &hour, &min, &sec,  &MJD1);
	printf("breakDownMJD %d %d %d %d %d %f\n", y, m, d, hour, min, sec);

	printf("%s\n", getMJDtimeVersion());
	setFromUT(2001, 1, 1, 1, 1, 0., &MJD1);
	breakDownMJD(&y, &m, &d, &hour, &min, &sec,  &MJD1);
	printf("breakDownMJD %d %d %d %d %d %f\n", y, m, d, hour, min, sec);
}

